#ifdef GL_ES
precision mediump float;
#endif

//written by adong
varying vec2 v_texCoord;
varying vec4 v_fragmentColor;

uniform vec3 shadow_color; 
uniform float dir_x;
uniform float dir_y;
uniform int range; // shadow range, set it to 12 

void main(void)  
{   
    int i;
    vec4 texColor = texture2D(CC_Texture0, v_texCoord);
	texColor.rgb = shadow_color;
	float inner = 0.0;
	float outter = 0.0;
	float count = 1.0;
	for (int k = -range;k<= range;++k){
		for(int j = -range;j<= range;++j){
			float a = texture2D(CC_Texture0, vec2(v_texCoord.x + float(k)*dir_x, v_texCoord.y+ float(j)*dir_y)).a;
			outter += 1.0 - a;
			inner += a;
			count += 1.0;
		}
	}
	inner /= count;
	outter /= count;
	float out_alpha = max(texColor.a,inner);
	float in_alpha = min(out_alpha,outter);
	texColor.a = in_alpha;
	gl_FragColor = texColor;
}   

