#ifdef GL_ES
precision mediump float;
#endif

//written by adong
varying vec2 v_texCoord;
varying vec4 v_fragmentColor;

uniform vec3 shadow_color; 
uniform float dir_x;
uniform float dir_y;
uniform int range; // shadow range, set it to 12 
uniform float strength; 


void main(void)  
{   
    int i;
    vec4 texColor = texture2D(CC_Texture0, v_texCoord);
	texColor.rgb = shadow_color;
	float a = texColor.a;
	int count = 1;
	float step = 1.0;
	float weight = strength;
	for(i=1;i<range;i++) {
		a += texture2D(CC_Texture0, vec2(v_texCoord.x - dir_x*step, v_texCoord.y)).a*weight ;
	   a += texture2D(CC_Texture0, vec2(v_texCoord.x  + dir_x*step, v_texCoord.y)).a*weight ;
	   a += texture2D(CC_Texture0, vec2(v_texCoord.x , v_texCoord.y+dir_y*step)).a*weight  ;
	   a += texture2D(CC_Texture0, vec2(v_texCoord.x,  v_texCoord.y+dir_y*step)).a *weight ;

	   a += texture2D(CC_Texture0, vec2(v_texCoord.x - dir_x*step, v_texCoord.y+dir_y*step)).a*weight ;
	   a += texture2D(CC_Texture0, vec2(v_texCoord.x  + dir_x*step, v_texCoord.y+dir_y*step)).a*weight ;
	   a += texture2D(CC_Texture0, vec2(v_texCoord.x - dir_x*step, v_texCoord.y-dir_y*step)).a*weight ;
	   a += texture2D(CC_Texture0, vec2(v_texCoord.x  + dir_x*step, v_texCoord.y-dir_y*step)).a*weight ;


	   step = step + 1.0;
	   weight = weight *0.9;
	   count = count + 8;
	}
	 
    texColor.a = a / float(count);

	gl_FragColor = texColor;
}   

